Attribute VB_Name = "mComDlg"
'mComDlg.bas
'2009 - Cyle Terry
'Licensed under the BSD license

Option Explicit

Private Declare Function GetSaveFileName _
  Lib "comdlg32.dll" _
  Alias "GetSaveFileNameA" ( _
  pOpenfilename As ComDlgInfo _
) As Long

Private Declare Function GetOpenFileName _
  Lib "comdlg32.dll" _
  Alias "GetOpenFileNameA" ( _
  pOpenfilename As ComDlgInfo _
) As Long

Private Declare Sub CoTaskMemFree _
  Lib "ole32.dll" ( _
  ByVal hMem As Long _
)

Private Declare Function lstrcat _
  Lib "kernel32" _
  Alias "lstrcatA" ( _
  ByVal lpString1 As String, _
  ByVal lpString2 As String _
) As Long

Private Declare Function SHBrowseForFolder _
  Lib "shell32" ( _
  lpbi As BrowseInfo _
) As Long

Private Declare Function SHGetPathFromIDList _
  Lib "shell32" ( _
  ByVal pidList As Long, _
  ByVal lpBuffer As String _
) As Long

Private Type ComDlgInfo
  lStructSize As Long
  hWndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter  As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  Flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

Private Type BrowseInfo
  hWndOwner As Long
  pIDLRoot As Long
  pszDisplayName As Long
  lpszTitle As Long
  ulFlags As Long
  lpfnCallback As Long
  lParam As Long
  iImage As Long
End Type

Public Enum DialogFlags
  AllowMultiSelect = &H200
  CreatePrompt = &H2000
  EnableHook = &H20
  EnableTemplate = &H40
  EnableTemplateHandle = &H80
  Explorer = &H80000
  ExtensionDifferent = &H400
  FileMustExist = &H1000
  HideReadOnly = &H4
  LongNames = &H200000
  NoChangeDir = &H8
  NoDereferenceLinks = &H100000
  NoLongNames = &H40000
  NoNetworkButton = &H20000
  NoReadOnlyReturn = &H8000
  NoTestFileCreate = &H10000
  NoValidate = &H100
  OverwritePrompt = &H2
  PathMustExist = &H800
  ReadOnly = &H1
  ShareAware = &H4000
  ShareFallThrough = &H2
  ShareNoWarn = &H1
  ShareWarn = &H0
  ShowHelp = &H10
End Enum

Private Const BIF_RETURNONLYFSDIRS = 1
Private Const MAX_PATH = 256

Sub SelectFile(ByRef rFile$(), sFilter$, sWnTitle$, Optional dzFlag As DialogFlags)
Dim ComDlg As ComDlgInfo
Dim cFilter$()
Erase rFile$()
'ComDlg.hWndOwner
ComDlg.hInstance = App.hInstance
'Put the extension in the file's description as well, it will save time and keep the source clean
'Error
If sFilter$ = vbNullString Then
cFilter = Split("All files|*.*", Chr$(Asc("|"))) '|
Else
cFilter = Split(sFilter$ & "|All files|*.*", Chr$(Asc("|"))) '|
sFilter$ = vbNullString
End If
Dim i As Integer
For i = 0 To UBound(cFilter) Step 2
sFilter$ = sFilter$ & cFilter(i) & " (" & cFilter(i + 1) & ")" & Chr$(0) & cFilter(i + 1) & Chr$(0)
Next i
ComDlg.lpstrFilter = sFilter$
ComDlg.lpstrFile = Space$(254)
ComDlg.nMaxFile = 255
ComDlg.lpstrFileTitle = Space$(254)
ComDlg.nMaxFileTitle = 255
ComDlg.lpstrTitle = sWnTitle$
ComDlg.Flags = dzFlag
ComDlg.lStructSize = Len(ComDlg)
If GetOpenFileName(ComDlg) Then
If (dzFlag And AllowMultiSelect) Then
Dim tempnum As Integer
Dim temp$
tempnum = InStrRev(ComDlg.lpstrFile, Chr$(0) & Chr$(0)) - 1
temp$ = Mid$(ComDlg.lpstrFile, 1, tempnum)
'temp$ = Left$(ComDlg.lpstrFile, Len(ComDlg.lpstrFile) - 2)
'temp$ = ComDlg.lpstrFile
If InStr(1, temp$, Chr$(0)) > 0 Then
Dim s$()
s = Split(ComDlg.lpstrFile, Chr$(0))
ReDim Preserve s$(UBound(s) - 2)
For i = 1 To UBound(s)
If s(i) = vbNullChar Then GoTo ni
ReDim Preserve rFile$(i - 1)
rFile$(i - 1) = s(0) & "\" & s(i)
ni:
Next i
Else
ReDim rFile$(0)
rFile$(0) = temp$
End If
Else
ReDim rFile$(0)
rFile$(0) = ComDlg.lpstrFile
rFile$(0) = Replace$(rFile$(0), Chr$(0), vbNullString)
rFile$(0) = Trim$(rFile$(0))
End If
Else
Erase rFile
End If
End Sub

Sub GetFile(rFile$(), sFilter$, sFile$, sWnTitle$, Optional dzFlag As DialogFlags)
Dim cFilter$()
Dim ComDlg As ComDlgInfo
Dim i As Integer
'ComDlg.hWndOwner
ComDlg.hInstance = App.hInstance
If sFilter$ = vbNullString Then
cFilter = Split("All files|*.*", "|")
Else
cFilter = Split(sFilter$ & "|All files|*.*", "|")
sFilter$ = vbNullString
End If
For i = 0 To UBound(cFilter) Step 2
sFilter$ = sFilter$ & cFilter(i) & " (" & cFilter(i + 1) & ")" & Chr$(0) & cFilter(i + 1) & Chr$(0)
Next i
ComDlg.lpstrFilter = sFilter$
If sFile$ = vbNullString Then
ComDlg.lpstrFile = Space$(254)
Else
ComDlg.lpstrFile = ReturnFiTitle$(sFile$) & Space$(254 - Len(ReturnFiTitle$(sFile$)))
End If
ComDlg.lpstrDefExt = ReturnFiExtension$(sFile$)
ComDlg.nMaxFile = 255
ComDlg.lpstrFileTitle = Space$(254)
ComDlg.nMaxFileTitle = 255
ComDlg.lpstrTitle = sWnTitle$
ComDlg.Flags = dzFlag
ComDlg.lStructSize = Len(ComDlg)
If GetSaveFileName(ComDlg) Then
ReDim rFile$(0)
rFile$(0) = ComDlg.lpstrFile
rFile$(0) = Replace$(rFile$(0), Chr$(0), vbNullString)
rFile$(0) = Trim$(rFile$(0))
Else
Erase rFile
End If
End Sub

Sub GetDir(ByRef rDir$(), sWnTitle$)
Dim iNull%
Dim lpIDList&
Dim udtBI As BrowseInfo
Dim sPath$
Erase rDir
With udtBI
'.hWndOwner = frmMain.hwnd
.lpszTitle = lstrcat(sWnTitle$, "")
.ulFlags = BIF_RETURNONLYFSDIRS
End With
lpIDList = SHBrowseForFolder(udtBI)
If lpIDList Then
ReDim rDir$(0)
rDir$(0) = String$(MAX_PATH, 0)
SHGetPathFromIDList lpIDList, rDir$(0)
CoTaskMemFree lpIDList
rDir$(0) = Replace$(rDir$(0), Chr$(0), vbNullString)
Else
Erase rDir
End If
End Sub
