Attribute VB_Name = "mMain"
'prjCDIWriter 0.1
'mMain.bas
'2009 - Cyle Terry
'Licensed under the BSD license

Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Declare Sub CopyMemory _
  Lib "kernel32" _
  Alias "RtlMoveMemory" ( _
  pDest As Any, _
  pSrc As Any, _
  ByVal ByteLen As Long _
)

Private Declare Function PathFileExists _
  Lib "shlwapi.dll" _
  Alias "PathFileExistsA" ( _
  ByVal pszPath As String _
) As Long

Private Declare Function GetTempPath _
  Lib "kernel32" _
  Alias "GetTempPathA" ( _
  ByVal nBufferLength As Long, _
  ByVal lpBuffer As String _
) As Long

Private cmd$
Private bootfile$()
Private dj_file$()
Private sb_dir$()
Private temp_dir$()

Const VERSION$ = "0.1"

Private Enum BinType
    ELF
    unscrambled
    scrambled
End Enum

Function ArrDims(arr As Variant) As Integer 'array(10, 10, 10, etc.)
  Dim address1 As Long 'address to array
  Dim address2 As Long 'address to array struct
  CopyMemory address1, ByVal VarPtr(arr) + 8, ByVal 4
  CopyMemory address2, ByVal address1, ByVal 4
  If address2 Then
    CopyMemory ArrDims, ByVal address2, 2
  Else
    ArrDims = address2
  End If
End Function
Sub CheckFiles()
  If ValidateFile(sb_dir$(0)) = False Then AboutInfo
End Sub
Sub GetTempDir()
  ReDim temp_dir$(0)
  temp_dir$(0) = String$(256, Chr$(0))
  GetTempPath 256, temp_dir$(0)
  temp_dir$(0) = Left$(temp_dir$(0), InStr(temp_dir$(0), Chr$(0)) - 1)
End Sub
Sub KillFileIfExists(str$) 'CompressZIt
  On Error Resume Next
  SetAttr str$, vbNormal
  Kill str$
End Sub
Function NormalizePath$(str$)
  If Left$(str, 1) <> "\" Then
    NormalizePath$ = str & "\"
  End If
End Function
Function RemoveLineEnder$(str$)
  RemoveLineEnder$ = Replace$(Replace$(str, Chr$(10), vbNullString), Chr$(13), vbNullString)
End Function
Function ReturnArg$(str$)
  Dim ao As Integer
  Dim po As Integer
  Dim alen As Integer
  Dim plen As Integer
  If Len(cmd) Then
    ao = InStr(1, cmd, str)
    If ao = 0 Then 'arg not found
      ReturnArg = vbNullString
      Exit Function
    End If
    alen = Len(str)
    po = ao + alen
    ReturnArg$ = Left$(Trim$(Mid(cmd, po)), 2)
    If Len(cmd) = (po - 1) Or ReturnArg$ = "--" Then 'no parameter
      ReturnArg$ = str
      Exit Function
    End If
    'set param
    plen = InStr(po, cmd, "--")
    If plen Then
      plen = plen - po
      ReturnArg$ = Trim$(Mid$(cmd, po, plen))
    Else
      ReturnArg$ = Trim$(Mid$(cmd, po))
    End If
  End If
End Function
Function ReturnCmd$()
  ReturnCmd$ = Replace$(Trim$(RemoveLineEnder$(Command$())), Chr$(34), vbNullString)
End Function
Function ReturnFiExtension$(str$)
  ReturnFiExtension$ = Mid$(Trim$(RemoveLineEnder$(str$)), InStrRev(str, Chr$(46)) + 1)
End Function
Function ReturnFiTitle$(str$)
  ReturnFiTitle$ = Mid$(Trim$(RemoveLineEnder$(str$)), InStrRev(str, Chr$(92)) + 1)
End Function
Function ReturnWoExtension$(str$) 'FIXME: no extensions
  Dim temp As String
  temp = ReturnFiTitle$(str$)
  If InStr(1, temp, Chr$(46)) Then
  ReturnWoExtension$ = Mid$(Trim$(RemoveLineEnder$(str)), 1, InStrRev(str, Chr$(46)) - 1)
  Else
  ReturnWoExtension$ = str$
  End If
End Function
Sub SetFiles()
  If Len(ReturnArg$("--dir")) Then
    ReDim sb_dir$(0)
    sb_dir$(0) = ReturnArg$("--dir")
  Else
    GetDir sb_dir$(), "Choose the folder to selfboot..."
    If ArrDims(sb_dir$) = 0 Then AboutInfo
  End If
  If Len(ReturnArg$("--cdi")) Then
    ReDim dj_file$(0)
    dj_file$(0) = ReturnArg$("--cdi")
  Else
    GetFile dj_file$(), "DiscJuggler|*.cdi", "", "Save your DiscJuggler file as...", FileMustExist
    If ArrDims(dj_file$) = 0 Then AboutInfo
  End If
End Sub
Function ValidateFile(str$) As Boolean
  ValidateFile = CBool(PathFileExists(str$))
End Function
Sub AboutInfo()
  'WriteLog "Unsucessful" & vbCrLf
  MsgBox App.Title & " " & VERSION & vbCrLf & _
    "Usage: " & App.EXEName & ".exe [--cdi <dj_file>] [--dir <sb_dir>] [--cdvol <cd_volume>] [--coder <your_name>]", , ""
  End
End Sub


Sub Main()
On Error GoTo ErrHandle

  cmd = ReturnCmd$()
  If Len(ReturnArg$("--help")) Then AboutInfo
  'SetLoggingStat
  SetFiles
  CheckFiles
  GetTempDir
  
  Selfboot sb_dir$(0)
Exit Sub
ErrHandle:
ErrHndl
End Sub


Sub BinChecker()
  Dim BinScan As BinType
  Dim elf_string$
  Dim abc_string$
  Dim number0_string$
  Dim number1_string$
  Dim unscramble1_string$
  Dim unscramble2_string$
  Dim unscramble3_string$
  Dim unscramble4_string$
  Dim unscramble5_string$
  Dim unscramble6_string$
  Dim unscramble7_string$
  Dim data$
    
  elf_string$ = Chr$(127) & "ELF"
  abc_string$ = "abcdefghijklmnopqrstuvwxyz"
  number0_string$ = "0123456789"
  number1_string$ = "1234567890"
  unscramble1_string$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ.0123456789-"
  unscramble2_string$ = "0123456789ABCDEF....Inf.NaN.0123456789abcdef....(null)..."
  unscramble3_string$ = "$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~"
  unscramble4_string$ = "PORTDEV INFOENBLSTATRADRTOUTDRQCFUNCEND"
  unscramble5_string$ = "abcdefghijklEFGHIJKLMNOPQRSTUVWXYZ!@#$%^&*()"
  unscramble6_string$ = "#...'...*...-.../...2...4...7...9...;...=...?...A...C...E...G...I...J...L...N...O...Q...R...T...U...W...X...Z..."
  unscramble7_string$ = "0123456789abcdef....(null)..0123456789ABCDEF"

  unscramble2_string$ = Replace$(unscramble2_string$, ".", Chr$(0))
  unscramble6_string$ = Replace$(unscramble6_string$, ".", Chr$(0))
  unscramble7_string$ = Replace$(unscramble7_string$, ".", Chr$(0))

  Open bootfile$(0) For Binary As #1
  ReDim btbootfile(LOF(1) - 1) As Byte
  Get #1, , btbootfile
  Close #1
    
  data$ = StrConv(btbootfile, vbUnicode)
  
  If Left$(data$, 4) = elf_string$ Then
    BinScan = ELF
    GoTo convert_bin
  End If
  If InStr(data$, abc_string$ & number0_string$) Or _
     InStr(data$, abc_string$ & number1_string$) Or _
     InStr(data$, number0_string$ & abc_string$) Or _
     InStr(data$, number1_string$ & abc_string$) Or _
     InStr(data$, unscramble1_string$) Or _
     InStr(data$, unscramble2_string$) Or _
     InStr(data$, unscramble3_string$) Or _
     InStr(data$, unscramble4_string$) Or _
     InStr(data$, unscramble5_string$) Or _
     InStr(data$, unscramble6_string$) Or _
     InStr(data$, unscramble7_string$) Then
    BinScan = unscrambled
  Else
    BinScan = scrambled
  End If

convert_bin:
  Select Case BinScan
    Case ELF
    ShellWait """" & NormalizePath$(App.Path$) & "sh-elf-objcopy.exe"" -O binary -R .stack """ & bootfile$(0) & """ """ & NormalizePath$(temp_dir$(0)) & "1ST_READ_UNSCRAMBLED.BIN""", vbNormalFocus
    If ValidateFile(NormalizePath$(temp_dir$(0)) & "1ST_READ_UNSCRAMBLED.BIN") = False Then
    MsgBox "Unknown error: sh-objcopy failed!", vbCritical, ""
    AboutInfo
    End If
    KillFileIfExists bootfile$(0)
    ShellWait """" & NormalizePath$(App.Path$) & "scramble.exe"" """ & NormalizePath$(temp_dir$(0)) & "1ST_READ_UNSCRAMBLED.BIN"" """ & NormalizePath$(sb_dir$(0)) & "1ST_READ.BIN""", vbNormalFocus
    If ValidateFile(NormalizePath$(sb_dir$(0)) & "1ST_READ.BIN") = False Then
    MsgBox "Unknown error: scramble failed!", vbCritical, ""
    AboutInfo
    End If
    KillFileIfExists NormalizePath$(sb_dir$(0)) & "1ST_READ_UNSCRAMBLED.BIN"
    bootfile$(0) = NormalizePath$(sb_dir$(0)) & "1ST_READ.BIN"
    Case unscrambled
    ShellWait """" & NormalizePath$(App.Path$) & "scramble.exe"" """ & bootfile$(0) & """ """ & ReturnWoExtension$(bootfile$(0)) & "_scrambled.bin"""
    If ValidateFile(ReturnWoExtension$(bootfile$(0)) & "_scrambled.bin") = False Then
    MsgBox "Unknown error: scramble failed!", vbCritical, ""
    AboutInfo
    End If
    KillFileIfExists bootfile$(0)
    Name ReturnWoExtension$(bootfile$(0)) & "_scrambled.bin" As bootfile$(0)
  End Select
End Sub

'TODO: Set bootfile$(0) if there's only one file
'TODO: Set bootfile$(0) if there's two files but the other one is a IP.BIN
'TODO: Set bootfile$(0) if all else fails and there's a ELF; done, maybe idiot proof it
'TODO: Check if ReturnFiTitle$(bootfile$(0)) > 16 characters
'FIXME: 1ST_READ.BIN and *.ELF is in sb_dir$(0)
Sub SetBootFile()
  If ValidateFile(NormalizePath$(sb_dir$(0)) & "1ST_READ.BIN") = True Then
    'default DC executable file name
    ReDim bootfile$(0)
    bootfile$(0) = NormalizePath$(sb_dir$(0)) & "1ST_READ.BIN"
  Else
    If ValidateFile(NormalizePath$(sb_dir$(0)) & "IP.BIN") = True Then
      'check the IP.BIN's boot file field and check if that boot file exists
      Dim ipbin_bootfile$(0)
      Dim btipbin_bootfile(15) As Byte
      
      Open NormalizePath$(sb_dir$(0)) & "IP.BIN" For Binary As #1
      Get #1, 97, btipbin_bootfile
      Close #1
      
      ipbin_bootfile$(0) = NormalizePath$(sb_dir$(0)) & Trim$(StrConv(btipbin_bootfile, vbUnicode))
      
      If ValidateFile(ipbin_bootfile$(0)) = True Then
        ReDim bootfile$(0)
        bootfile$(0) = ipbin_bootfile$(0)
      End If
    End If
  End If
  If Len(Dir$(NormalizePath$(sb_dir$(0)) & "*.elf")) Then
    ReDim bootfile$(0)
    bootfile$(0) = NormalizePath$(sb_dir$(0)) & Dir$(NormalizePath$(sb_dir$(0)) & "*.elf")
  End If
  
  If ArrDims(bootfile$) = 0 Then
    MsgBox "The DC bootfile could not be located!", vbCritical, ""
    AboutInfo
  End If
End Sub

'TODO: Check if ReturnFiTitle$(bootfile$(0)) > 16 characters
Sub ValidateIPBIN(ipbin$)
  If ValidateFile(ipbin$) = True Then
    Dim ipbin_bootfile$(0)
    Open ipbin$ For Binary As #1
    ReDim btipbin_bootfile(15) As Byte
    Get #1, 97, btipbin_bootfile()
    Close #1
    
    ipbin_bootfile$(0) = Trim$(StrConv(btipbin_bootfile, vbUnicode))
    
    If ipbin_bootfile$(0) <> bootfile$(0) Then
    Open ipbin$ For Binary As #1
    Put #1, 97, StrConv(Space$(16), vbFromUnicode)
    Put #1, 97, ReturnFiTitle$(UCase$(bootfile$(0)))
    Close #1
    End If
  Else
    Dim hardwareid As String * 16
    Dim makerid As String * 16
    Dim deviceinfo As String * 16
    Dim areasymbols As String * 8
    Dim periphflags As String * 8
    Dim productnum As String * 10
    Dim productver As String * 6
    Dim releasedate As String * 16
    Dim companyname As String * 16
    Dim softwarename As String * 128
  
    hardwareid = "SEGA SEGAKATANA"
    makerid = "SEGA ENTERPRISES"
    deviceinfo = "B6D8 CD-ROM1/1"
    areasymbols = "JUE"
    periphflags = "E000010"
    productnum = "T0000"
    productver = "V1.000"
    releasedate = Format$(Now, "yyyymmdd")
    If Len(ReturnArg$("--coder")) Then
    companyname = ReturnArg$("--coder")
    Else
    companyname = "dcbasic"
    End If
    If Len(ReturnArg$("--cdvol")) Then
    softwarename = ReturnArg$("--cdvol")
    Else
    softwarename = "CDI Writer " & VERSION
    End If
    
    Open NormalizePath$(App.Path$) & "IP.TMPL" For Binary As #1
    ReDim iptemplate(32511) As Byte
    Get #1, 257, iptemplate()
    Close #1
    
    Open NormalizePath$(sb_dir$(0)) & "IP.BIN" For Binary As #1
    Put #1, , hardwareid
    Put #1, , makerid
    Put #1, , deviceinfo
    Put #1, , areasymbols
    Put #1, , periphflags
    Put #1, , productnum
    Put #1, , productver
    Put #1, , releasedate
    Put #1, , ReturnFiTitle$(UCase$(bootfile$(0))) & Space$(16 - Len(ReturnFiTitle$(bootfile$(0))))
    Put #1, , companyname
    Put #1, , softwarename
    Put #1, , iptemplate()
    Close #1
  End If
End Sub


Sub Selfboot(folder$)
  Dim cd_volume$
  Dim ms&
  
  ms& = GetTickCount&
  
  SetBootFile
  BinChecker
  ValidateIPBIN NormalizePath$(folder$) & "IP.BIN"
  
  If Len(ReturnArg$("--cdvol")) Then
    cd_volume = ReturnArg$("--cdvol")
  Else
    cd_volume = ReturnFiTitle$(sb_dir$(0))
  End If
  KillFileIfExists NormalizePath$(temp_dir$(0)) & "data.iso"
  Name NormalizePath$(folder$) & "IP.BIN" As NormalizePath$(App.Path$) & "IP.BIN"
  ShellWait """" & NormalizePath$(App.Path$) & "mkisofs.exe"" -G """ & NormalizePath$(App.Path$) & "IP.BIN"" -C 0,11702 -J -l -r -V """ & cd_volume & """ -o """ & NormalizePath$(temp_dir$(0)) & "data.iso"" """ & sb_dir$(0) & """", vbNormalFocus
  Name NormalizePath$(App.Path$) & "IP.BIN" As NormalizePath$(folder$) & "IP.BIN"
  If ValidateFile(NormalizePath$(temp_dir$(0)) & "data.iso") = True Then
  If DateDiff("s", FileDateTime(NormalizePath$(temp_dir$(0)) & "data.iso"), Now) > Int((GetTickCount& - ms&) / 60) Then
  MsgBox "Unknown error: mkisofs ISO time mismatch!", vbCritical, ""
  AboutInfo
  End If
  Else
  MsgBox "Unknown error: mkisofs failed!", vbCritical, ""
  AboutInfo
  End If
  
  KillFileIfExists dj_file$(0)
  ShellWait """" & NormalizePath$(App.Path$) & "cdi4dc.exe"" """ & NormalizePath$(temp_dir$(0)) & "data.iso"" """ & dj_file$(0) & """", vbNormalFocus
  If ValidateFile(NormalizePath$(temp_dir$(0)) & "data.iso") = True Then
  If DateDiff("s", FileDateTime(dj_file$(0)), Now) > Int((GetTickCount& - ms&) / 60) Then
  MsgBox "Unknown error: cdi4dc CDI time mismatch!", vbCritical, ""
  AboutInfo
  End If
  Else
  MsgBox "Unknown error: cdi4dc failed!", vbCritical, ""
  AboutInfo
  End If
  KillFileIfExists NormalizePath$(temp_dir$(0)) & "data.iso"
End Sub

