Attribute VB_Name = "mShell"
'mShell.bas
'2009 - Cyle Terry
'Licensed under the BSD license

Option Explicit

Private Declare Function CreateProcessA _
  Lib "kernel32" ( _
  ByVal lpApplicationName As Long, _
  ByVal lpCommandLine As String, _
  ByVal lpProcessAttributes As Any, _
  ByVal lpThreadAttributes As Any, _
  ByVal bInheritHandles As Long, _
  ByVal dwCreationFlags As Long, _
  ByVal lpEnvironment As Long, _
  ByVal lpCurrentDirectory As Long, _
  lpStartupInfo As Any, _
  lpProcessInformation As Any _
) As Long

Private Declare Function WaitForSingleObject _
  Lib "kernel32" ( _
  ByVal hHandle As Long, _
  ByVal dwMilliseconds As Long _
) As Long

Private Declare Function CloseHandle _
  Lib "kernel32" ( _
  ByVal hObject As Long _
) As Long

Private Type StartupInfo
  cb As Long
  lpReserved As Long
  lpDesktop As Long
  lpTitle As Long
  dwX As Long
  dwY As Long
  dwXSize As Long
  dwYSize As Long
  dwXCountChars As Long
  dwYCountChars As Long
  dwFillAttribute As Long
  dwFlags As Long
  wShowWindow As Integer
  cbReserved2 As Integer
  lpReserved2 As Long
  hStdInput As Long
  hStdOutput As Long
  hStdError As Long
End Type

Private Type ProcessInfo
  hProcess As Long
  hThread As Long
  dwProcessId As Long
  dwThreadID As Long
End Type

Const STARTF_USESHOWWINDOW = &H1
Const NORMAL_PRIORITY_CLASS = &H20
Const INFINITE As Long = -1

Sub ShellWait(it As String, Optional ByVal WindowStyle As Long)
Dim udtStart As StartupInfo
Dim udtProc As ProcessInfo
udtStart.cb = Len(udtStart)
If Not IsMissing(WindowStyle) Then
udtStart.dwFlags = STARTF_USESHOWWINDOW
udtStart.wShowWindow = WindowStyle
End If
CreateProcessA 0&, it, 0&, 0&, 1&, NORMAL_PRIORITY_CLASS, 0&, 0&, udtStart, udtProc
WaitForSingleObject udtProc.hProcess, INFINITE
CloseHandle udtProc.hProcess
End Sub
